"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.between = void 0;
const types_1 = require("../types");
const seq_1 = require("./seq");
/** Parses a sequence of three parsers.
 * @returns A parser returning only the middle parser's result.
 */
function between(left, parser, right) {
    const sequence = (0, seq_1.seq)(left, parser, right);
    return (ctx) => {
        const res = sequence(ctx);
        if ((0, types_1.isFailure)(res)) {
            const newHistory = [...res.history];
            newHistory.splice(0, 1);
            return (0, types_1.failure)(res.ctx, res.expected, ['between', ...newHistory]);
        }
        return { ...res, value: res.value[1] };
    };
}
exports.between = between;
