"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.regex = void 0;
const types_1 = require("../types");
/** Parses a regex and returns the matched result of the parse.
 * @returns A parser parsing a given regex and returning a match.
 */
function regex(match, expected) {
    const regexp = new RegExp(match, typeof match === 'string' ? 'y' : match.flags + 'y');
    return (ctx) => {
        regexp.lastIndex = ctx.index;
        const regexMatch = regexp.exec(ctx.text);
        if (regexMatch !== null && regexMatch.index === ctx.index) {
            return (0, types_1.success)({ ...ctx, index: ctx.index + regexMatch[0].length }, regexMatch[0]);
        }
        else {
            return (0, types_1.failure)(ctx, expected, [expected]);
        }
    };
}
exports.regex = regex;
